package io.xjar.filter;

import java.util.Collection;
import io.xjar.XEntryFilter;

public class XAnyEntryFilter<E> extends XMixEntryFilter<E> implements XEntryFilter<E>
{
    public XAnyEntryFilter() {
        super(null);
    }
    
    public XAnyEntryFilter(final Collection<? extends XEntryFilter<? extends E>> filters) {
        super(filters);
    }
    
    @Override
    public XAnyEntryFilter<E> mix(final XEntryFilter<? extends E> filter) {
        this.add(filter);
        return this;
    }
    
    public boolean filtrate(final E entry) {
        final XEntryFilter[] array;
        final XEntryFilter[] filters = array = this.filters.toArray(new XEntryFilter[0]);
        for (final XEntryFilter filter : array) {
            if (filter.filtrate((Object)entry)) {
                return true;
            }
        }
        return false;
    }
}
